#include <iostream>
using namespace std;

struct Date {
	short day;
	short month;
	short year;
	bool isCorrect();
};

bool Date::isCorrect()
{
	bool result = false;

	if (month > 0 && month <= 12 && year <= 2021)
	{
		switch (month)
		{
		case 1:
		case 3:
		case 5:
		case 7:
		case 8:
		case 10:
		case 12:
		{
			if ((day <= 31) && (day > 0))
				result = true;
			break;
		}

		case 4:
		case 6:
		case 9:
		case 11:
		{
			if ((day <= 30) && (day > 0))
				result = true;
			break;
		}

		case 2:
		{
			if (year % 4 != 0)
			{
				if ((day <= 28) && (day > 0))
					result = true;
			}
			else
				if (year % 400 == 0)
				{
					if ((day <= 29) && (day > 0))
						result = true;
				}
				else
					if ((year % 100 == 0) && (year % 400 != 0))
					{
						if ((day == 28) && (day > 0))
							result = true;
					}
					else
						if ((year % 4 == 0) && (year % 100 != 0))
							if ((day <= 29) && (day > 0))
								result = true;
			break;
		}

		default:
			result = false;
		}
	}
	return result;
}

struct Student
{
	char F[56];
	char I[32];
	char O[32];
	Date birthday;
	char address[256];
	short mark;
};

void task1()
{
	const int N = 2;
	Student group[N];

	for (int i = 0; i < N; i++)
	{
		cout << "\nInput F: ";
		cin.ignore(std::cin.rdbuf()->in_avail());
		cin.getline(group[i].F, 56);

		cout << "\nIinput I: ";
		cin.ignore(std::cin.rdbuf()->in_avail());
		cin.getline(group[i].I, 32);

		cout << "\nInput O: ";
		cin.ignore(std::cin.rdbuf()->in_avail());
		cin.getline(group[i].O, 32);

		do
		{
			cout << "\nInput birthday: ";
			cin.ignore(std::cin.rdbuf()->in_avail());
			cin >> group[i].birthday.day >> group[i].birthday.month >> group[i].birthday.year;
		} while (!group[i].birthday.isCorrect());

		cout << "\nInput address:";
		cin.ignore(std::cin.rdbuf()->in_avail());
		cin.getline(group[i].address, 256);

		cout << "\nInput mark:";
		cin.ignore(std::cin.rdbuf()->in_avail());
		cin >> group[i].mark;

		cin.clear();
	}

	for (int i = 0; i < N; i++)
	{
		cout << "\nFIO: " << group[i].F << " " << group[i].I << " " << group[i].O;
		cout << "\nBirthday: " << group[i].birthday.day << "." << group[i].birthday.month << "." << group[i].birthday.year;
		cout << "\nAddress: " << group[i].address << endl;
		cout << "Mark: " << group[i].mark << endl;
	}

	int best = 0;
	for (int i = 0; i < N; i++)
	{
		if (group[i].mark > group[best].mark)
			best = i;
	}

	cout << "\nFIO: " << group[best].F << " " << group[best].I << " " << group[best].O << " is the best!";
}



struct Book
{
	char title[200];
	char authors[512];
	short published = 2021;
	char publisher[64];

	void printInfo();
	void readInfo();
};

void Book::printInfo()
{
	cout << endl << "Book:" << endl;
	cout << "title: " << title << endl;
	cout << "authors: " << authors << endl;
	cout << "publishing year: " << published << endl;
	cout << "publisher: " << publisher << endl;
}

void Book::readInfo()
{
	cout << "\nInput book title: ";
	cin.ignore(std::cin.rdbuf()->in_avail());
	cin.getline(title, sizeof(title));

	cout << "\nInput book authors: ";
	cin.ignore(std::cin.rdbuf()->in_avail());
	cin.getline(authors, sizeof(authors));

	cout << "\nInput book publishing year: ";
	cin >> published;

	cout << "\nInput book publisher: ";
	cin.ignore(std::cin.rdbuf()->in_avail());
	cin.getline(publisher, sizeof(publisher));
}

void task2() {
/*	
	Book book;

	book.readInfo();
	book.printInfo();
*/
	const int N = 3;
	Book library[N];

	for (size_t i = 0; i < N; i++)
	{
		library[i].readInfo();
	}

	for (size_t i = 0; i < N; i++)
	{
		library[i].printInfo();
	}

	int indexOfOldestBook = 0;
	int averageYear = library[0].published;
	for (size_t i = 1; i < N; i++)
	{
		if (library[i].published < library[indexOfOldestBook].published)
			indexOfOldestBook = i;	

		averageYear += library[i].published;
	}
	
	cout << endl << "Average publishing year of all books is: " << (float)averageYear/N;

	cout << endl << "The oldest book is: ";
	library[indexOfOldestBook].printInfo();
}

int main()
{
	// task1();

	task2();

	return 0;
}